Bug 843695 - Review Request: gecode - Generic constraint development environment
Review Request: gecode - Generic constraint development environment
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-27 00:57 EDT by Julian C. Dunn
Modified: 2015-06-29 11:57 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-02 20:49:23 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Julian C. Dunn 2012-07-27 00:57:40 EDT
Spec URL: http://fedorapeople.org/~jdunn/gecode/gecode.spec
SRPM URL: http://fedorapeople.org/~jdunn/gecode/gecode-3.7.3-1.fc18.src.rpm
Description:

Gecode is a toolkit for developing constraint-based systems and
applications. Gecode provides a constraint solver with state-of-the-art
performance while being modular and extensible.

Fedora Account System Username: jdunn
Comment 1 Mario Blättermann 2012-08-18 14:20:05 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4401812


$ rpmlint -i -v *
gecode.i686: I: checking
gecode.i686: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode.i686: W: shared-lib-calls-exit /usr/lib/libgecodegist.so.32.0 exit@GLIBC_2.0
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode.i686: W: shared-lib-calls-exit /usr/lib/libgecodeflatzinc.so.32.0 exit@GLIBC_2.0
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode.i686: W: shared-lib-calls-exit /usr/lib/libgecodedriver.so.32.0 exit@GLIBC_2.0
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode.src: I: checking
gecode.src: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode.src: I: checking-url http://www.gecode.org/download/gecode-3.7.3.tar.gz (timeout 10 seconds)
gecode.x86_64: I: checking
gecode.x86_64: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode.x86_64: W: shared-lib-calls-exit /usr/lib64/libgecodeflatzinc.so.32.0 exit@GLIBC_2.2.5
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode.x86_64: W: shared-lib-calls-exit /usr/lib64/libgecodedriver.so.32.0 exit@GLIBC_2.2.5
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode.x86_64: W: shared-lib-calls-exit /usr/lib64/libgecodegist.so.32.0 exit@GLIBC_2.2.5
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode-debuginfo.i686: I: checking
gecode-debuginfo.i686: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode-debuginfo.x86_64: I: checking
gecode-debuginfo.x86_64: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode-devel.i686: I: checking
gecode-devel.i686: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode-devel.i686: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

gecode-devel.i686: W: no-manual-page-for-binary fz
Each executable in standard binary directories should have a man page.

gecode-devel.i686: W: no-manual-page-for-binary mzn-gecode
Each executable in standard binary directories should have a man page.

gecode-devel.x86_64: I: checking
gecode-devel.x86_64: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode-devel.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

gecode-devel.x86_64: W: no-manual-page-for-binary fz
Each executable in standard binary directories should have a man page.

gecode-devel.x86_64: W: no-manual-page-for-binary mzn-gecode
Each executable in standard binary directories should have a man page.

gecode-doc.noarch: I: checking
gecode-doc.noarch: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode-examples.noarch: I: checking
gecode-examples.noarch: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode.spec: I: checking-url http://www.gecode.org/download/gecode-3.7.3.tar.gz (timeout 10 seconds)
9 packages and 1 specfiles checked; 0 errors, 12 warnings.



Some of the issues can be ignored, such as the missing docs and manpages. Your package looks almost fine, but there is a recognizable issue:

gecode.x86_64: W: shared-lib-calls-exit /usr/lib64/libgecodegist.so.32.0 exit@GLIBC_2.2.5
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

Well, this is no review blocker, because you are the packager and cannot fix such bugs. But it is worth to inform the upstream people about that.


Just a few objections from me:

%{name} = %{version}-%{release}
has to be for the -devel package
%{name}%{?_isa} = %{version}-%{release}

because it is no "noarch" package.


The -doc package owns the folder %{_defaultdocdir}/%{name}-doc-%{version}/html, but not the parent folder %{_defaultdocdir}/%{name}-doc-%{version}. Please add this as %dir or just use %{_defaultdocdir}/%{name}-doc-%{version}.
Comment 2 Julian C. Dunn 2012-08-22 09:54:52 EDT
Mario,

I've fixed the objections you pointed out and the new spec/SRPM is here:

Spec URL: http://fedorapeople.org/~jdunn/gecode/gecode.spec
SRPM URL: http://fedorapeople.org/~jdunn/gecode/gecode-3.7.3-2.fc19.src.rpm

Additionally, I did raise the fact that the gecode library calls exit() with upstream. Their response:

"This has come up a number of times.  The exit is only called when a buggy callback (i.e. user code) throws an exception in Gist.  I'll have a look and display an error dialog instead."

So I hope it will be fixed in a later version.
Comment 3 Mario Blättermann 2012-08-23 05:00:30 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4416529

$ rpmlint -i -v *
gecode.i686: I: checking
gecode.i686: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode.i686: W: shared-lib-calls-exit /usr/lib/libgecodegist.so.32.0 exit@GLIBC_2.0
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode.i686: W: shared-lib-calls-exit /usr/lib/libgecodeflatzinc.so.32.0 exit@GLIBC_2.0
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode.i686: W: shared-lib-calls-exit /usr/lib/libgecodedriver.so.32.0 exit@GLIBC_2.0
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode.src: I: checking
gecode.src: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode.src: I: checking-url http://www.gecode.org/download/gecode-3.7.3.tar.gz (timeout 10 seconds)
gecode.x86_64: I: checking
gecode.x86_64: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode.x86_64: W: shared-lib-calls-exit /usr/lib64/libgecodeflatzinc.so.32.0 exit@GLIBC_2.2.5
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode.x86_64: W: shared-lib-calls-exit /usr/lib64/libgecodedriver.so.32.0 exit@GLIBC_2.2.5
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode.x86_64: W: shared-lib-calls-exit /usr/lib64/libgecodegist.so.32.0 exit@GLIBC_2.2.5
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

gecode-debuginfo.i686: I: checking
gecode-debuginfo.i686: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode-debuginfo.x86_64: I: checking
gecode-debuginfo.x86_64: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode-devel.i686: I: checking
gecode-devel.i686: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode-devel.i686: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

gecode-devel.i686: W: no-manual-page-for-binary fz
Each executable in standard binary directories should have a man page.

gecode-devel.i686: W: no-manual-page-for-binary mzn-gecode
Each executable in standard binary directories should have a man page.

gecode-devel.x86_64: I: checking
gecode-devel.x86_64: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode-devel.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

gecode-devel.x86_64: W: no-manual-page-for-binary fz
Each executable in standard binary directories should have a man page.

gecode-devel.x86_64: W: no-manual-page-for-binary mzn-gecode
Each executable in standard binary directories should have a man page.

gecode-doc.noarch: I: checking
gecode-doc.noarch: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode-examples.noarch: I: checking
gecode-examples.noarch: I: checking-url http://www.gecode.org/ (timeout 10 seconds)
gecode.spec: I: checking-url http://www.gecode.org/download/gecode-3.7.3.tar.gz (timeout 10 seconds)
9 packages and 1 specfiles checked; 0 errors, 12 warnings.


The same exit() calls and the same missing man pages again. No recognizable issues.



---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    MIT
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[.] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    e7cc8bcc18b49195fef0544061bdd2e484a1240923e4e85fa39e8d6bb492854c  gecode-3.7.3.tar.gz
    e7cc8bcc18b49195fef0544061bdd2e484a1240923e4e85fa39e8d6bb492854c  gecode-3.7.3.tar.gz.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[+] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[.] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[.] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[+] MUST: Development files must be in a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[.] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).

[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[+] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.


----------------

PACKAGE APPROVED

----------------
Comment 4 Julian C. Dunn 2012-08-23 11:50:48 EDT
New Package SCM Request
=======================
Package Name: gecode
Short Description: Generic constraint development environment
Owners: jdunn
Branches: f17 f18 el6
InitialCC:
Comment 5 Gwyn Ciesla 2012-08-23 11:58:58 EDT
Git done (by process-git-requests).
Comment 6 Fedora Update System 2012-08-24 08:02:47 EDT
gecode-3.7.3-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/gecode-3.7.3-3.fc17
Comment 7 Fedora Update System 2012-08-24 08:03:43 EDT
gecode-3.7.3-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/gecode-3.7.3-3.fc18
Comment 8 Fedora Update System 2012-08-24 08:05:04 EDT
gecode-3.7.3-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/gecode-3.7.3-3.el6
Comment 9 Fedora Update System 2012-08-24 17:33:23 EDT
gecode-3.7.3-3.fc18 has been pushed to the Fedora 18 testing repository.
Comment 10 Julian C. Dunn 2012-08-24 21:14:00 EDT
Package Change Request
======================
Package Name: gecode
New Branches: f16
Owners: jdunn
InitialCC: 

Would like to support Fedora 16 as well as some users need it.
Comment 11 Gwyn Ciesla 2012-08-25 09:46:56 EDT
Git done (by process-git-requests).
Comment 12 Fedora Update System 2012-08-25 12:03:11 EDT
gecode-3.7.3-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/gecode-3.7.3-3.fc16
Comment 13 Fedora Update System 2012-09-02 20:49:23 EDT
gecode-3.7.3-3.fc17 has been pushed to the Fedora 17 stable repository.
Comment 14 Fedora Update System 2012-09-09 14:32:34 EDT
gecode-3.7.3-3.el6 has been pushed to the Fedora EPEL 6 stable repository.
Comment 15 Fedora Update System 2012-09-11 20:31:00 EDT
gecode-3.7.3-3.fc16 has been pushed to the Fedora 16 stable repository.
Comment 16 Fedora Update System 2012-09-17 18:28:35 EDT
gecode-3.7.3-3.fc18 has been pushed to the Fedora 18 stable repository.
Comment 17 Julian C. Dunn 2015-06-29 00:59:55 EDT
Package Change Request
======================
Package Name: gecode
New Branches: epel7
Owners: jdunn
Comment 18 Gwyn Ciesla 2015-06-29 11:57:05 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.